# $Revision: 1.59 $, $Date: 2005/01/18 20:51:33 $
#
# Conditional build:
%bcond_with	bootstrap
#

%define		DASHED_SNAP	%{nil}
%define		SNAP		%(echo %{DASHED_SNAP} | sed -e "s#-##g")
%define		GCC_VERSION	3.4.3
%define		apiver		3.2
%define		apisrc		w32api-%{apiver}
%define		runver		3.7
%define		runsrc		mingw-runtime-%{runver}
Summary:	Cross Mingw32 GNU binary utility development utilities - gcc
Summary(es):	Utilitarios para desarrollo de binarios de la GNU - Mingw32 gcc
Summary(fr):	Utilitaires de dveloppement binaire de GNU - Mingw32 gcc
Summary(pl):	Skrone narzdzia programistyczne GNU dla Mingw32 - gcc
Summary(pt_BR): Utilitrios para desenvolvimento de binrios da GNU - Mingw32 gcc
Summary(tr):	GNU gelitirme aralar - Mingw32 gcc
Name:		crossmingw32-gcc
Version:	%{GCC_VERSION}
Release:	4
Epoch:		1
License:	GPL
Group:		Development/Languages
Source0:	ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{GCC_VERSION}/gcc-%{GCC_VERSION}.tar.bz2
# Source0-md5:	e744b30c834360fccac41eb7269a3011
Source1:	http://dl.sourceforge.net/mingw/%{apisrc}.tar.gz
# Source1-md5:	ea357143f74f05a0ddccc0d2bebe9b03
Source2:	http://dl.sourceforge.net/mingw/%{runsrc}.tar.gz
# Source2-md5:	33db567db9a2034a44bf216762049df4
Patch0:		gcc-nodebug.patch
Patch1:		%{name}-noioctl.patch
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	crossmingw32-binutils >= 2.15.91.0.2-2
BuildRequires:	flex
%if %{without bootstrap}
BuildRequires:	crossmingw32-runtime >= 3.5
BuildRequires:	crossmingw32-w32api >= 3.1
%endif
Requires:	crossmingw32-binutils >= 2.15.91.0.2-2
Requires:	gcc-dirs
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%define		target		i386-mingw32
%define		target_platform i386-pc-mingw32
%define		arch		%{_prefix}/%{target}
%define		gccarch		%{_libdir}/gcc/%{target}
%define		gcclib		%{_libdir}/gcc/%{target}/%{version}

%description
crossmingw32 is a complete cross-compiling development system for
building stand-alone Microsoft Windows applications under Linux using
the Mingw32 build libraries. This includes a binutils, gcc with g++
and objc, and libstdc++, all cross targeted to i386-mingw32, along
with supporting Win32 libraries in 'coff' format from free sources.

This package contains cross targeted gcc.

%description -l de
Dieses Paket enthlt einen Cross-gcc, der es erlaubt, auf einem
anderem Rechner Code fr Win32 zu generieren.

%description -l pl
crossmingw32 jest kompletnym systemem do kompilacji skronej,
pozwalajcym budowa aplikacje MS Windows pod Linuksem uywajc
bibliotek Mingw32. System skada si z binutils, gcc z g++ i objc,
libstdc++ - wszystkie generujce kod dla platformy i386-mingw32, oraz
z bibliotek w formacie COFF.

Ten pakiet zawiera gcc generujce skronie kod dla Win32.

%package c++
Summary:	Mingw32 binary utility development utilities - g++
Summary(pl):	Zestaw narzdzi mingw32 - g++
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description c++
crossmingw32 is a complete cross-compiling development system for
building stand-alone Microsoft Windows applications under Linux using
the Mingw32 build libraries. This includes a binutils, gcc with g++
and objc, and libstdc++, all cross targeted to i386-mingw32, along
with supporting Win32 libraries in 'coff' format from free sources.

This package contains cross targeted g++ and (static) libstdc++.

%description c++ -l pl
crossmingw32 jest kompletnym systemem do kompilacji skronej,
pozwalajcym budowa aplikacje MS Windows pod Linuksem uywajc
bibliotek mingw32. System skada si z binutils, gcc z g++ i objc,
libstdc++ - wszystkie generujce kod dla platformy i386-mingw32, oraz
z bibliotek w formacie COFF.

Ten pakiet zawiera g++ generujce kod pod Win32 oraz bibliotek
libstdc++.

# does this even work?
%package objc
Summary:	Mingw32 binary utility development utilities - objc
Summary(pl):	Zestaw narzdzi mingw32 - objc
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description objc
crossmingw32 is a complete cross-compiling development system for
building stand-alone Microsoft Windows applications under Linux using
the Mingw32 build libraries. This includes a binutils, gcc with g++
and objc, and libstdc++, all cross targeted to i386-mingw32, along
with supporting Win32 libraries in 'coff' format from free sources.

This package contains cross targeted objc.

%description objc -l pl
crossmingw32 jest kompletnym systemem do kompilacji skronej,
pozwalajcym budowa aplikacje MS Windows pod Linuksem uywajc
bibliotek mingw32. System skada si z binutils, gcc z g++ i objc,
libstdc++ - wszystkie generujce kod dla platformy i386-mingw32, oraz
z bibliotek w formacie COFF.

Ten pakiet zawiera kompilator objc generujcy kod pod Win32.

# does this even work?
%package g77
Summary:	Mingw32 binary utility development utilities - g77
Summary(pl):	Zestaw narzdzi mingw32 - g77
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description g77
crossmingw32 is a complete cross-compiling development system for
building stand-alone Microsoft Windows applications under Linux using
the Mingw32 build libraries. This includes a binutils, gcc with g++
and objc, and libstdc++, all cross targeted to i386-mingw32, along
with supporting Win32 libraries in 'coff' format from free sources.

This package contains cross targeted g77.

%description g77 -l pl
crossmingw32 jest kompletnym systemem do kompilacji skronej,
pozwalajcym budowa aplikacje MS Windows pod Linuksem uywajc
bibliotek mingw32. System skada si z binutils, gcc z g++ i objc,
libstdc++ - wszystkie generujce kod dla platformy i386-mingw32, oraz
z bibliotek w formacie COFF.

Ten pakiet zawiera g77 generujcy kod pod Win32.

# does this even work?
%package java
Summary:	Mingw32 binary utility development utilities - java
Summary(pl):	Zestaw narzdzi mingw32 - java
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description java
crossmingw32 is a complete cross-compiling development system for
building stand-alone Microsoft Windows applications under Linux using
the Mingw32 build libraries. This includes a binutils, gcc with g++
and objc, and libstdc++, all cross targeted to i386-mingw32, along
with supporting Win32 libraries in 'coff' format from free sources.

This package contains cross targeted java.

%description java -l pl

crossmingw32 jest kompletnym systemem do kompilacji skronej,
pozwalajcym budowa aplikacje MS Windows pod Linuksem uywajc
bibliotek mingw32. System skada si z binutils, gcc z g++ i objc,
libstdc++ - wszystkie generujce kod dla platformy i386-mingw32, oraz
z bibliotek w formacie COFF.

Ten pakiet zawiera kompilator Javy generujcy kod pod Win32.

%prep
%setup -q -c
cd gcc-%{version}
%if %{with bootstrap}
mkdir winsup
tar xzf %{SOURCE1} -C winsup
tar xzf %{SOURCE2} -C winsup
%endif
%{!?debug:%patch0 -p1}
%patch1 -p1

%build
cd gcc-%{version}
%if %{with bootstrap}
for tool in as ar dlltool ld nm ranlib strip ; do
	ln -sf %{arch}/bin/$tool winsup/bin/$tool
done
build_tooldir=`pwd`/winsup
%else
build_tooldir=%{arch}
%endif

cp /usr/share/automake/config.sub .
cp /usr/share/automake/config.sub boehm-gc

rm -rf obj-%{target_platform} && install -d obj-%{target_platform} && cd obj-%{target_platform}

# note: alpha's -mieee and sparc's -mtune=* are not valid for target's g++
CFLAGS="%{rpmcflags}" \
%ifarch alpha
CXXFLAGS="`echo '%{rpmcflags}' | sed -e 's/ \?-mieee\>//'`" \
%else
%ifarch sparc sparc64 sparcv9
CXXFLAGS="`echo '%{rpmcflags}' | sed -e 's/ \?-mtune[=0-9a-z]*//'`" \
%else
CXXFLAGS="%{rpmcflags}" \
%endif
%endif
LDFLAGS="%{rpmldflags}" \
TEXCONFIG=false \
../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--bindir=%{arch}/bin \
	--libdir=%{_libdir} \
	--libexecdir=%{_libexecdir} \
	--includedir=%{arch}/include \
	--enable-languages="c,c++,f77,java,objc" \
	--with-gnu-as \
	--with-gnu-ld \
	--with-gxx-include-dir=%{arch}/include/g++ \
	--enable-threads \
	--build=%{_target_platform} \
	--host=%{_target_platform} \
	--target=%{target}

#touch ../gcc/c-gperf.h

%{__make} \
	LDFLAGS_FOR_TARGET="%{rpmldflags}" \
	TARGET_LIBGCC2_CFLAGS="-UCROSS_COMPILE" \
	build_tooldir="$build_tooldir" \
	FLAGS_FOR_TARGET="-B${build_tooldir}/bin -B${build_tooldir}/lib -isystem ${build_tooldir}/include -nostdinc" \
	CFLAGS_FOR_TARGET="-nostdinc" \
	NM_FOR_TARGET="%{target}-nm"

# build libobjc.dll for Objective C
# it must be called from obj-%{target_platform}/%{target}/libobjc, but
# GCC_FOR_TARGET must be passed
#
#make -C %{target}/libobjc \
#	LDFLAGS="%{rpmldflags}" \
#	TARGET_LIBGCC2_CFLAGS="-UCROSS_COMPILE" \
#	DLLTOOL="%{target}-dlltool --as=%{target}-as" libobjc.dll

# spec files for msvcrt*.dll configurations
cd gcc
for n in msvcrt msvcrt20 msvcrt40; do
	sed "s/crtdll/$n/g" <specs | sed "s/crt1/crt2/g" >specs.$n
done

%install
rm -rf $RPM_BUILD_ROOT
cd gcc-%{version}

install -d $RPM_BUILD_ROOT%{_bindir}
install -d $RPM_BUILD_ROOT%{_datadir}
cd obj-%{target_platform}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cd gcc
install specs.msvcrt specs.msvcrt20 specs.msvcrt40 $RPM_BUILD_ROOT%{gcclib}
cd ../..

mv -f $RPM_BUILD_ROOT%{arch}/bin/%{target}-* $RPM_BUILD_ROOT%{_bindir}

# already in arch/lib, shouldn't be here
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a

%if 0%{!?debug:1}
# strip linux binaries
strip -R .comment -R .note \
	`echo $RPM_BUILD_ROOT{%{_bindir}/*,%{arch}/bin/*} | grep -v gccbug` \
	$RPM_BUILD_ROOT%{gcclib}/{cc1*,f771,jc1,jvgenmain}

# strip mingw32 libraries
%{target}-strip -g \
	$RPM_BUILD_ROOT%{gcclib}/libgcc.a \
	$RPM_BUILD_ROOT%{arch}/lib/lib*.a
%endif

# restore hardlinks
ln -f $RPM_BUILD_ROOT%{_bindir}/%{target}-{g++,c++}
ln -f $RPM_BUILD_ROOT%{arch}/bin/{g++,c++}

# the same... make hardlink
ln -f $RPM_BUILD_ROOT%{arch}/bin/gcc $RPM_BUILD_ROOT%{_bindir}/%{target}-gcc

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{target}-gcc*
%attr(755,root,root) %{_bindir}/%{target}-cpp
%attr(755,root,root) %{_bindir}/%{target}-gcov
%attr(755,root,root) %{arch}/bin/gcc
%{arch}/lib/libiberty.a

%dir %{gccarch}
%dir %{gcclib}
%attr(755,root,root) %{gcclib}/cc1
%{gcclib}/libgcc.a
%{gcclib}/libgcov.a
%{gcclib}/specs*
%{gcclib}/include

%{_mandir}/man1/%{target}-cpp.1*
%{_mandir}/man1/%{target}-gcc.1*
%{_mandir}/man1/%{target}-gcov.1*

%files c++
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{target}-[cg]++
%attr(755,root,root) %{arch}/bin/[cg]++
%attr(755,root,root) %{gcclib}/cc1plus
%{arch}/lib/libstdc++.a
%{arch}/lib/libstdc++.la
%{arch}/lib/libsupc++.a
%{arch}/lib/libsupc++.la
%{arch}/include/g++
%{_mandir}/man1/%{target}-g++.1*

%files objc
%defattr(644,root,root,755)
%attr(755,root,root) %{gcclib}/cc1obj
%{arch}/lib/libobjc.a
%{arch}/lib/libobjc.la

%files g77
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{target}-g77
%attr(755,root,root) %{gcclib}/f771
%{arch}/lib/libfrtbegin.a
%{arch}/lib/libg2c.a
%{arch}/lib/libg2c.la
%{_mandir}/man1/%{target}-g77.1*

%files java
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{target}-gcj
%attr(755,root,root) %{_bindir}/%{target}-gcjh
%attr(755,root,root) %{_bindir}/%{target}-grepjar
%attr(755,root,root) %{_bindir}/%{target}-jar
%attr(755,root,root) %{_bindir}/%{target}-jcf-dump
%attr(755,root,root) %{_bindir}/%{target}-jv-scan
#%attr(755,root,root) %{arch}/bin/grepjar
#%attr(755,root,root) %{arch}/bin/jar
%attr(755,root,root) %{gcclib}/jc1
%attr(755,root,root) %{gcclib}/jvgenmain
%{_mandir}/man1/%{target}-gcj.1*
%{_mandir}/man1/%{target}-gcjh.1*
%{_mandir}/man1/%{target}-grepjar.1*
%{_mandir}/man1/%{target}-jar.1*
%{_mandir}/man1/%{target}-jcf-dump.1*
%{_mandir}/man1/%{target}-jv-scan.1*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: crossmingw32-gcc.spec,v $
Revision 1.59  2005/01/18 20:51:33  wolf
- rel 4

Revision 1.58  2005/01/16 17:56:33  qboosh
- md5 for proper tarballs

Revision 1.57  2005/01/16 17:53:16  qboosh
- w32api 3.2, runtime 3.7

Revision 1.56  2004/11/10 13:47:03  paladine
- cosmetics

Revision 1.55  2004/11/06 22:23:08  wolf
- 3.4.3

Revision 1.54  2004/10/08 04:52:43  ankry
- R: gcc-dirs, rel++

Revision 1.53  2004/09/22 22:30:23  jareq
- updated to w32api 3.1
- updated to runtime 3.5
- updated to binutils 2.15.91.0.2-2
- rel 2

Revision 1.52  2004/09/10 15:49:01  jareq
- Update to 3.4.2

Revision 1.51  2004/07/20 11:40:45  qboosh
- strict internal deps

Revision 1.50  2004/07/20 11:36:41  qboosh
- de fix(?) (not only i386)

Revision 1.49  2004/07/09 21:19:55  qboosh
- two more manuals

Revision 1.48  2004/07/09 12:45:33  wolf
- 3.4.1

Revision 1.47  2004/05/31 19:28:27  qboosh
- package few more files

Revision 1.46  2004/05/08 18:28:53  wolf
- 3.4.0

Revision 1.45  2004/02/19 09:51:40  qboosh
- back to release 1

Revision 1.44  2004/02/19 09:04:20  qboosh
- syntax fix; temporary release 0.1 for sparc bootstrap

Revision 1.43  2004/02/19 08:59:03  qboosh
- remove -mtune=* from target g++ options (sparc)

Revision 1.42  2004/02/18 22:04:51  qboosh
- updated gcc to 3.3.3, w32api 2.5; added nodebug patch

Revision 1.41  2004/01/24 23:57:39  undefine
- %{arch}/%{_lib} to %{arch}/lib - it crosscompiler libraries

Revision 1.40  2004/01/24 21:07:48  wolf
- another try at amd64

Revision 1.39  2004/01/24 20:01:38  wolf
- amd64 fixes

Revision 1.38  2004/01/20 09:18:45  qboosh
- try to fix alpha

Revision 1.37  2004/01/18 20:35:39  undefine
- fix amd64 support

Revision 1.36  2004/01/18 20:20:05  wolf
- amd64 support (?)

Revision 1.35  2003/12/19 13:56:50  undefine
- release 1 to rebuild without bootstrap

Revision 1.34  2003/10/20 13:32:52  jareq
- upgrade gcc to 3.3.2
- upgrade runtime to 3.2
- upgrade winapi to 2.4

Revision 1.33  2003/08/29 23:30:32  ankry
- sync summaries / descriptions; some BR fixed

Revision 1.32  2003/08/21 07:08:56  ankry
- s/kroskompilator/kompilator skrony/, drop capitals

Revision 1.31  2003/08/18 08:07:58  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.30  2003/08/09 18:44:44  qboosh
- fixed changelog, removed rubbish

Revision 1.29  2003/08/09 13:46:33  jareq
- upgrade to gcc 3.3.1 (missing commit log, sorry)

Revision 1.28  2003/08/09 13:38:36  jareq
- *** empty log message ***

Revision 1.26  2003/07/04 16:08:06  wiget
- no more exclusivearch

Revision 1.25  2003/07/04 15:40:24  wiget
- added bootstrap bcond to build using binary w32api and ming-runtime
- added --host and --build to force crosscompilation
- release 2

Revision 1.24  2003/06/27 13:10:44  mmazur
- mass commit; now req: name = epoch:version

Revision 1.23  2003/05/26 16:24:51  malekith
- massive attack: adding Source-md5

Revision 1.22  2003/05/25 05:46:28  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.21  2003/05/17 09:11:13  qboosh
- updated to 3.3
- added noioctl patch needed to compile libstdc++

Revision 1.20  2003/04/27 10:13:28  qboosh
- updated to gcc 3.2.3
- removed unneeded slibdir patch

Revision 1.19  2003/04/05 18:22:40  qboosh
- updated to 3.2.2
- changed R: -platform to -w32api
- added missing libraries for c++,objc,g77,java
- manually strip binaries and libs using appropriate strip programs
  (rpm automation can't deal with this)

Revision 1.18  2002/12/14 19:55:19  ggodlewski
- gcc 3.2.1

Revision 1.17  2002/07/13 14:35:51  michuz
- updated to 3.1 because previous version didn't compile

Revision 1.16  2002/04/25 16:07:34  arturs
fixed a small typo

Revision 1.15  2002/04/22 16:03:40  ankry
- fixed URL for gcc sources.

Revision 1.14  2002/02/23 01:44:57  kloczek
- adapterized.

Revision 1.13  2002/02/22 23:28:46  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.12  2002/01/18 02:12:36  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.11  2001/10/09 22:33:13  qboosh
- don't call autoconf in ./libiberty/ - it was not necessary and broke build
- release 7

Revision 1.10  2001/06/14 16:09:45  qboosh
- pl summaries & descriptions

Revision 1.9  2001/05/02 16:29:01  qboosh
- adapterized and made spec %%debug ready or added using %%rpm*flags macros

Revision 1.8  2001/05/02 00:42:07  qboosh
- adapterized and made spec %%debug ready or using %%rpm*flags macros

Revision 1.7  2001/03/22 18:43:28  qboosh
- final 2.95.3
- release 6

Revision 1.6  2001/03/15 18:27:59  qboosh
- 2.95.3-test5

Revision 1.5  2001/03/08 22:53:40  qboosh
- 2.95.3.test4
- release 4

Revision 1.4  2001/01/31 21:03:14  qboosh
- 2.95.3.test3
- release 3

Revision 1.3  2001/01/26 18:50:19  qboosh
- 2.95.3.test2
- use -O0 instead of -O when building debug version
- release 2

Revision 1.2  2001/01/19 17:22:42  qboosh
- update to 2.95.3.test1
- use gcc version as package version (Epoch=1 to allow upgrade)
- some cleanup
- subpackages: c++, objc, g77, chill, java

Revision 1.1  2000/12/11 08:36:40  qboosh
- almost rewritten, split into 3 packages
- BuildRoot, updates, patches and other stuff...

* Mon Jan 11 1999 David Sugar <dyfet@tycho.com>
- Modified heavily and then added all other useful stuff to cross build
  a complete mingw32 development system in a single RPM.  The original
  RPMS's would not build from source unless /usr/i386-ming32 already
  had cross-compiled lib stuff, so this one directly builds into
  /usr/i386-mingw32 rather than a buildroot so that it can be cleanly
  built on a system that was NEVER used for cross compiling before.  If
  somebody wants to untwist this web and make it buildroot friendly...

* Thu May 7 1998 Jan-Jaap van der Heijden <J.J.vanderHeijden@student.utwente.nl>
- Initial release (2.9.1)
